PROGRAM DCF32;
USES Windows,Messages;
{$R DCF32.RES}


TYPE tSecSet=SET OF 0..59;

{*************************************************************************************************}
{*                                                                                               *}
{*   DCF 77 Stuff                                                                                *}
{*                                                                                               *}
{*************************************************************************************************}

CONST
  INI_SECTION = 'DCF 77 DECODER';
  AppName     = 'DCF_77_DECODER';
  Caption  : ARRAY[0..22] OF Char = 'DCF 77 DECODER';
  Days     : ARRAY[0..7]OF pChar=('So','Mo','Di','Mi','Do','Fr','Sa','So');
  Hour     : Byte=0;
  Min      : Byte=0;
  Sec      : Byte=0;
  DoW      : Byte=0;
  Day      : Byte=0;
  Month    : Byte=0;
  Year     : Byte=0;
  RecBuf   : tSecSet=[];
  Comm     : Word=0;
  LastTime : Longint=0;
  CharW    : WORD=08;
  CharH    : WORD=13;

PROCEDURE PaintTime(aDC:hDC);FORWARD;

FUNCTION CalcTime:Boolean;ASSEMBLER;
ASM
    ; {Check Bits: 1-14=0; 20=1}
    mov  ax,word ptr RecBuf
    and  ax,$7FFE
    or   ax,ax
    jne  @Error
    ; {Checksummen 21-27}
    mov  ecx,7
    xor  edx,edx
    xor  eax,eax
    mov  ax,word ptr RecBuf+2
    shr  eax,5
@l1:shr  eax,1
    adc  edx,0
    loop @l1
    and  al,1
    and  dl,1
    cmp  al,dl
    jne  @Error
    ; {Checksummen 29-34}
    mov  ecx,6
    xor  edx,edx
    mov  ax,word ptr RecBuf+3
    shr  ax,5
@l2:shr  eax,1
    adc  edx,0
    loop @l2
    and  al,1
    and  dl,1
    cmp  al,dl
    jne  @Error
    ; {Checksummen 36-57}
    xor  edx,edx
    mov  ecx,22
    mov  eax,dword ptr RecBuf+4
    shr  eax,4
@l3:shr  eax,1
    adc  edx,0
    loop @l3
    and  al,1
    and  dl,1
    cmp  al,dl
    jne  @Error
    ; {Zeit dekodieren}
    ; {Minuten: Bits 21..24 Lo; 25-27..Hi; 28 Paritt}
    mov  ax,word ptr RecBuf+2 ; {Bits 16-31}
    shr  ax,5
    mov  ah,al
    and  al,15
    cmp  al,9
    ja   @Error
    shr  ah,4
    and  ah,7
    aad  ; {bcd>bin}
    cmp  al,59
    ja   @Error
    mov  Min,al
    ; {Stunden: Bits 29..32 Lo; 33,34..Hi; 35 Paritt}
    mov  ax,word ptr RecBuf+3 ; {Bits 24-39}
    shr  ax,5
    mov  ah,al
    and  al,15
    cmp  al,9
    ja   @Error
    shr  ah,4
    and  ah,3
    aad  ; {bcd>bin}
    cmp  al,23
    ja   @Error
    mov  Hour,al
    ; {Tag: Bits 36..39 Lo; 40,41..Hi}
    mov  ax,word ptr RecBuf+4 ; {Bits 32-47}
    shr  ax,4
    mov  ah,al
    and  al,15
    cmp  al,9
    ja   @Error
    shr  ah,4
    and  ah,3
    aad  ; {bcd>bin}
    cmp  al,31
    ja   @Error
    mov  Day,al
    ; {Wochentag: Bits 42..44}
    mov  ax,word ptr RecBuf+5 ; {Bits 40-55}
    shr  ax,2
    and  al,7
    mov  DoW,al
    ; {Monat: Bits 45..48 Lo; 49 Hi;}
    mov  ax,word ptr RecBuf+5 ; {Bits 40-55}
    shr  ax,5
    mov  ah,al
    and  al,15
    cmp  al,9
    ja   @Error
    shr  ah,4
    and  ah,1
    aad  ; {bcd>bin}
    cmp  al,12
    ja   @Error
    mov  Month,al
    ; {Jahr: Bits 50..53 Lo; 54-57..Hi; 58 Paritt fr Tag,Wochentag,Monat,Jahr}
    mov  ax,word ptr RecBuf+6 ; {Bits 48-63}
    shr  ax,2
    mov  ah,al
    and  al,15
    cmp  al,9
    ja   @Error
    shr  ah,4
    and  ah,15
    aad  ; {bcd>bin}
    cmp  al,99
    ja   @Error
    mov  Year,al
    jmp @Exit
@Error:
    xor ax,ax
    jmp @Out
@Exit:
    mov ax,1
@Out:
END;

FUNCTION InitCom(PortNo:Longint):Boolean;
VAR PC          : ARRAY[0..20]OF Char;
    CommState   : tDCB;
BEGIN
  InitCom:=False;
  IF NOT PortNo in [1..8]THEN Exit;
  wvsPrintF(@PC,'Com%d',@PortNo);
  Comm:=_lOpen(PC,OF_READ);
  IF (Comm<>INVALID_HANDLE_VALUE)AND GetCommState(Comm,CommState) THEN
  BEGIN
    CommState.BaudRate  :=50;
    CommState.ByteSize  :=8;
    CommState.Parity    :=NoParity;
    CommState.StopBits  :=OneStopBit;
    SetCommState(Comm,CommState);
    EscapeCommFunction(Comm,SetRTS);
    EscapeCommFunction(Comm,CLRDTR);
    LastTime:=GetTickCount;
    Sec:=0;
    RecBuf:=[];
    InitCom:=True;
  END;
END;

PROCEDURE DoneCom;
BEGIN
  EscapeCommFunction(Comm,CLRRTS);
  EscapeCommFunction(Comm,SETDTR);
  _lClose(Comm);
  Sec:=0;
  RecBuf:=[];
END;

FUNCTION CheckComm:Boolean;
VAR Siz        : DWord;
    LastChar   : Byte;
    SysTime    : tSystemTime;
BEGIN
  Siz:=_lRead(Comm,@LastChar,1);
  CheckComm:=Siz>0;
  IF Siz>0 THEN
  BEGIN
    IF (GetTickCount-LastTime>1500)OR(Sec>58) THEN
    BEGIN
      IF (Sec=58)AND(CalcTime) THEN
      BEGIN
        SysTime.wYear:=1900+Year;
        IF Year<97 THEN  Inc(SysTime.wYear,100);
        SysTime.wMonth:=Month;
        SysTime.wDayOfWeek:=DoW;
        SysTime.wDay:=Day;
        SysTime.wHour:=Hour;
        SysTime.wMinute:=Min;
        SysTime.wSecond:=0;
        SysTime.wMilliseconds:=0;
        SetLocalTime(Systime);
        GetLocalTime(Systime);{}
        Year:=SysTime.wYear-1900;
        Month:=SysTime.wMonth;
        DOW:=SysTime.wDayOfWeek;
        Day:=SysTime.wDay;
        Hour:=SysTime.wHour;
        Min:=SysTime.wMinute;
      END;
      Sec:=0;
      RecBuf:=[];
    END ELSE
    BEGIN
      Inc(Sec);
      IF LastChar>100 THEN Exclude(RecBuf,Sec) ELSE Include(RecBuf,Sec);
    END;
    PaintTime(0);
    LastTime:=GetTickCount;
  END;
END;

{*************************************************************************************************}
{*                                                                                               *}
{*   Usage                                                                                       *}
{*                                                                                               *}
{*************************************************************************************************}

PROCEDURE Usage;
BEGIN
  MessageBox(0,'Usage: DCF32 <n>'#9'where n ist the number of the COM'#10+
                #9#9'port with the DCF77 module',NIL,MB_IconStop);
  Halt(0);
END;

{*************************************************************************************************}
{*                                                                                               *}
{*   Window Handling                                                                             *}
{*                                                                                               *}
{*************************************************************************************************}
VAR
  hWindow   : hWnd;
  attr      : RECORD x,y,w,h:integer; END;
  Pt        : tPoint;
  OldPt     : tPoint;
  LCD       : hBitmap;

CONST UP=1;
      Down=0;
PROCEDURE frame3D(MalDC:hDC;x,y,dx,dy:integer;width:byte;up_down:byte);
VAR i:integer;
    a,b:Longint;
    pa:hpen;
BEGIN
  IF up_down=down THEN
  BEGIN
    a:=GetSysColor(Color_BtnShadow);
    b:=GetSysColor(Color_BtnHighLight);
  END
  ELSE
  BEGIN
    a:=GetSysColor(Color_BtnHighLight);
    b:=GetSysColor(Color_BtnShadow);
  END;
  pa:=selectobject(Maldc,createpen(ps_solid,1,a));
  FOR i:=0 TO width-1 DO
  BEGIN  movetoex(Maldc,x+dx-1-i,y+i,nil);lineto(Maldc,x+i,y+i);lineto(Maldc,x+i,y+dy-1-i); END;
  deleteobject(selectobject(Maldc,createpen(ps_solid,1,b)));
  FOR i:=0 TO width-1 DO
  BEGIN movetoex(Maldc,x+i,y+dy-1-i,nil);lineto(Maldc,x+dx-1-i,y+dy-1-i);lineto(Maldc,x+dx-1-i,y+i);END;
  deleteobject(selectobject(Maldc,createpen(ps_solid,1,GetSysColor(Color_BtnFace))));
  movetoex(Maldc,x+dx-1,y,nil); lineto(Maldc,x+dx-1-width,y+width);
  movetoex(Maldc,x,y+dy-1,nil); lineto(Maldc,x+width,y+dy-1-width);
  deleteobject(selectobject(Maldc,pa));
END;

PROCEDURE PaintTime(aDC:hDC);
VAR DC     : hDC;
    MemDC  : hDC;
    MemDC1 : hDC;
    bmp    : hBitmap;
    St,rSt : STRING;
    I      : Word;
    J      : Word;
    K      : Word;
    L      : Word;
BEGIN
  IF aDC=0 THEN DC:=GetDC(hWindow) ELSE DC:=aDC;
  MemDC  :=CreateCompatibleDC(DC);
  LCD    :=SelectObject(MemDC,LCD);
  MemDC1 :=CreateCompatibleDC(DC);
  BMP    :=CreateCompatibleBitmap(DC,Attr.W,Attr.H);
  BMP    :=SelectObject(MemDC1,BMP);
  STR(Day,St);
  IF Day<10 THEN St:='0'+St;rSt:=St;
  STR(Month,St);
  IF Month<10 THEN St:='0'+St;rSt:=rSt+':'+St;
  STR(Year,St);
  IF Year<10 THEN St:='0'+St;rSt:=rSt+':'+St;
  K:=0;L:=0;
  FOR I:=0 TO Length(rSt)-1 DO
  BEGIN
    J:=Ord(rSt[I+1]);
    CASE J OF
    45     : BEGIN J:=13*CharW;K:=CharW;END;
    46     : BEGIN J:=14*CharW+4;K:=CharW DIV 2;END;
    48..57 : BEGIN DEC(J,47);J:=J*CharW; K:=CharW; END;
    58     : BEGIN J:=14*CharW;K:=CharW DIV 2;END;
    END;
    Bitblt(MemDC1,L,0,K,CharH,MemDC,J,0,SRCCOPY);
    INC(L,K);
  END;
  Bitblt(DC,22,10,L,CharH,MemDC1,0,0,SRCCOPY);
  STR(Hour,St);
  IF Hour<10 THEN St:='0'+St;rSt:=St;
  STR(Min,St);
  IF Min<10 THEN St:='0'+St;rSt:=rSt+':'+St;
  STR(Sec,St);
  IF Sec<10 THEN St:='0'+St;rSt:=rSt+':'+St;
  K:=0;L:=0;
  FOR I:=0 TO Length(rSt)-1 DO
  BEGIN
    J:=Ord(rSt[I+1]);
    CASE J OF
    45     : BEGIN J:=13*CharW;K:=CharW;END;
    46     : BEGIN J:=14*CharW+4;K:=CharW DIV 2;END;
    48..57 : BEGIN DEC(J,47);J:=J*CharW; K:=CharW; END;
    58     : BEGIN J:=14*CharW;K:=CharW DIV 2;END;
    END;
    Bitblt(MemDC1,L,0,K,CharH,MemDC,J,0,SRCCOPY);
    INC(L,K);
  END;
  Bitblt(DC,22,30,L,CharH,MemDC1,0,0,SRCCOPY);
  BMP    :=SelectObject(MemDC1,BMP);
  DeleteObject(BMP);
  DeleteDC(MemDC1);
  LCD    :=SelectObject(MemDC,LCD);
  DeleteDC(MemDC);
  IF aDC=0 THEN ReleaseDC(hWindow,DC);
END;

PROCEDURE ReDraw;
VAR DC    : hDC;
    Rect  : tRect;
BEGIN
{Year,Month,Day,DoW,Hour,Min,Sec);}
  DC:=GetDC(hWindow);
  setBKcolor(DC,GetSysColor(Color_BtnFace));
  settextcolor(DC,GetSysColor(Color_BtnText));
  settextalign(DC,ta_center or ta_top);
  SetRect(Rect,0,0,Attr.W,Attr.H);
  FillRect(DC,Rect,GetStockObject(BLACK_BRUSH));
  Frame3D(DC,0,0,(attr.w),attr.h,2,up);
  Frame3D(DC,2,2,(attr.w-4),attr.h-4,2,down);
  PaintTime(DC);
  ReleaseDC(hWindow,DC);
END;

FUNCTION WndProc(hWnd : HWND; MSG : uInt; wParam : WParam; lParam : LParam) : Longint; STDCALL;
BEGIN
  WndProc:=0;
  CASE MSG OF
    WM_EndSession:Halt(0);
    WM_SetCursor:
      CASE HiWord(lparam) OF
        wm_lbuttondown:
          WITH Attr DO
          BEGIN
            GetCursorPos(Pt);
            {move window}
            OldPt:=Pt;
            Dec(pt.x,x);
            Dec(pt.y,y);
            WHILE (GetAsyncKeyState(VK_lButton)AND$8000)=$8000 DO
            BEGIN
              GetCursorPos(tPoint((@attr)^));
              Dec(x,pt.x);
              Dec(Y,pt.y);
              movewindow(hwindow,x,y,w,h,true);
            END;
          END;
        ELSE WndProc:=DefWindowProc( hWnd, MSG, wParam, lParam );
      END;
    WM_TIMER: CheckComm;
    WM_EraseBkGnd: ReDraw;
    WM_KeyUp: IF wParam=vk_Escape THEN PostQuitMessage(0);
    ELSE WndProc:=DefWindowProc( hWnd, MSG, wParam, lParam );
  END;
END;

FUNCTION Init(hInst:THandle):Boolean;
VAR WCLASS:TWndClass;
BEGIN
  WITH WCLASS DO
  BEGIN
    hCursor      :=LoadCursor(0,IDC_ARROW);
    hIcon        :=LoadIcon(hinst, MakeIntResource(100));
    lpszMenuName :=NIL;
    lpszClassName:=AppName;
    hbrBackground:=0;
    hInstance    :=hInst;
    style        :=cs_bytealignclient OR cs_bytealignwindow;
    lpfnWndProc  :=@WndProc;
    cbClsExtra   :=0 ;
    cbWndExtra   :=0 ;
  END;
  Init:=RegisterClass(WClass)<>0;
END;

{*************************************************************************************************}
{*                                                                                               *}
{*   Main                                                                                        *}
{*                                                                                               *}
{*************************************************************************************************}
VAR S   : Word;
    Msg : TMsg;
    St  : STRING;
BEGIN
  IF (ParamCount<>1) OR (Length(Paramstr(1))<>1) THEN Usage;
  S:=Ord(ParamStr(1)[1])-Ord('0');
  IF NOT S IN [1..4] THEN Usage;
  Comm:=$FFFF;
  IF InitCom(S) THEN
  BEGIN
    Init(HInstance);
    hWindow:=CreateWindowEx(WS_EX_ToolWindow,AppName,Caption,ws_popup OR ws_visible,0,0,0,0,0,0,hInstance,NIL);
    IF hWindow=0 THEN Messagebox(0,'Could not create valid Window!','ERROR',mb_iconstop) ELSE
    BEGIN
      LCD:=LoadBitmap(hInstance,'LCD_08X13');
      WITH attr DO
      BEGIN
        x:=GetProfileInt(INI_SECTION,'X',20);
        y:=GetProfileInt(INI_SECTION,'Y',20);
        w:=GetProfileInt(INI_SECTION,'W',100);
        h:=GetProfileInt(INI_SECTION,'H',50);
        IF (y+h)>GetSystemMetrics(SM_CYScreen) THEN y:=GetSystemMetrics(SM_cyscreen)-h;
        IF (x+w)>GetSystemMetrics(SM_cxscreen) THEN x:=GetSystemMetrics(SM_cxscreen)-w;
        IF x<0 THEN x:=0;
        IF y<0 THEN y:=0;
        SetWindowPos(hwindow,hwnd_notopmost,x,y,w,h,swp_noactivate);
        Redraw;
      END;
      SetTimer(hWindow,10,250,NIL);{}
      WHILE GetMessage(Msg,0,0,0) DO
      BEGIN
        TranslateMessage(Msg);
        DispatchMessage(Msg);
      END;
      KillTimer(hWindow,10);{}
      WITH Attr DO
      BEGIN
        Str(Attr.x,St); St:=St+#0;WriteProfileString(INI_SECTION,'X',@St[1]);
        Str(Attr.y,St); St:=St+#0;WriteProfileString(INI_SECTION,'Y',@St[1]);
        Str(Attr.w,St); St:=St+#0;WriteProfileString(INI_SECTION,'W',@St[1]);
        Str(Attr.h,St); St:=St+#0;WriteProfileString(INI_SECTION,'H',@St[1]);
      END;
      IF LCD<>0 THEN DeleteObject(LCD);
      DestroyWindow(hWindow);
      UnRegisterClass(AppName,hInstance);
    END;
    DoneCom;
  END;
END.

