PROGRAM Receiver;
USES WinTypes,WinProcs,WinCrt,WinDOS,Strings;
{$R RECEIVER.RES}

TYPE tSecSet=SET OF 0..59;

CONST
  Days     : ARRAY[0..7]OF pChar=('So','Mo','Di','Mi','Do','Fr','Sa','So');
  Hour     : Byte=0;
  Min      : Byte=0;
  Sec      : Byte=0;
  DoW      : Byte=0;
  Day      : Byte=0;
  Month    : Byte=0;
  Year     : Byte=0;
  RecBuf   : tSecSet=[];
  Comm     : Integer=0;
  LastTime : Longint=0;

FUNCTION CalcTime:Boolean;ASSEMBLER;
ASM
    ; {Check Bits: 1-14=0; 20=1}
    mov  ax,word ptr RecBuf
    and  ax,$7FFE
    or   ax,ax
    jne  @Error
    ; {Checksummen 21-27}
    mov  cx,7
    xor  dx,dx
    mov  ax,word ptr RecBuf+2
    shr  ax,5
@l1:shr  ax,1
    adc  dx,0
    loop @l1
    and  al,1
    and  dl,1
    cmp  al,dl
    jne  @Error
    ; {Checksummen 29-34}
    mov  cx,6
    xor  dx,dx
    mov  ax,word ptr RecBuf+3
    shr  ax,5
@l2:shr  ax,1
    adc  dx,0
    loop @l2
    and  al,1
    and  dl,1
    cmp  al,dl
    jne  @Error
    ; {Checksummen 36-57}
    xor  dx,dx
    mov  cx,12
    mov  ax,word ptr RecBuf+4
    shr ax,4
@l30:
    shr ax,1
    adc  dx,0
    loop @l30
    mov  cx,10
    mov ax,word ptr RecBuf+6
@l31:
    shr  ax,1
    adc  dx,0
    loop @l31
    and  al,1
    and  dl,1
    cmp  al,dl
    jne  @Error
    ; {Zeit dekodieren}
    ; {Minuten: Bits 21..24 Lo; 25-27..Hi; 28 Paritt}
    mov  ax,word ptr RecBuf+2 ; {Bits 16-31}
    shr  ax,5
    mov  ah,al
    and  al,15
    cmp  al,9
    ja   @Error
    shr  ah,4
    and  ah,7
    aad  ; {bcd>bin}
    cmp  al,59
    ja   @Error
    mov  Min,al
    ; {Stunden: Bits 29..32 Lo; 33,34..Hi; 35 Paritt}
    mov  ax,word ptr RecBuf+3 ; {Bits 24-39}
    shr  ax,5
    mov  ah,al
    and  al,15
    cmp  al,9
    ja   @Error
    shr  ah,4
    and  ah,3
    aad  ; {bcd>bin}
    cmp  al,23
    ja   @Error
    mov  Hour,al
    ; {Tag: Bits 36..39 Lo; 40,41..Hi}
    mov  ax,word ptr RecBuf+4 ; {Bits 32-47}
    shr  ax,4
    mov  ah,al
    and  al,15
    cmp  al,9
    ja   @Error
    shr  ah,4
    and  ah,3
    aad  ; {bcd>bin}
    cmp  al,31
    ja   @Error
    mov  Day,al
    ; {Wochentag: Bits 42..44}
    mov  ax,word ptr RecBuf+5 ; {Bits 40-55}
    shr  ax,2
    and  al,7
    mov  DoW,al
    ; {Monat: Bits 45..48 Lo; 49 Hi;}
    mov  ax,word ptr RecBuf+5 ; {Bits 40-55}
    shr  ax,5
    mov  ah,al
    and  al,15
    cmp  al,9
    ja   @Error
    shr  ah,4
    and  ah,1
    aad  ; {bcd>bin}
    cmp  al,12
    ja   @Error
    mov  Month,al
    ; {Jahr: Bits 50..53 Lo; 54-57..Hi; 58 Paritt fr Tag,Wochentag,Monat,Jahr}
    mov  ax,word ptr RecBuf+6 ; {Bits 48-63}
    shr  ax,2
    mov  ah,al
    and  al,15
    cmp  al,9
    ja   @Error
    shr  ah,4
    and  ah,15
    aad  ; {bcd>bin}
    cmp  al,99
    ja   @Error
    mov  Year,al
    jmp @Exit
@Error:
    xor ax,ax
    jmp @Out
@Exit:
    mov ax,1
@Out:
END;

FUNCTION InitCom(PortNo:Longint):Boolean;
VAR PC          : ARRAY[0..20]OF Char;
    CommState   : tDCB;
BEGIN
  InitCom:=False;
  IF NOT PortNo in [1..8]THEN Exit;
  wvsPrintF(PC,'Com%d',PortNo);
  Comm:=OpenComm(PC,512,512);
  IF (Comm>=0)AND(GetCommState(Comm,CommState)=0) THEN
  BEGIN
    CommState.BaudRate  :=50;
    CommState.ByteSize  :=8;
    CommState.Parity    :=NoParity;
    CommState.StopBits  :=OneStopBit;
    CommState.Flags     :=dcb_Binary;
    SetCommState(CommState);
    EscapeCommFunction(Comm,SetRTS);
    EscapeCommFunction(Comm,CLRDTR);
    LastTime:=GetTickCount;
    Sec:=0;
    RecBuf:=[];
    InitCom:=True;
  END;
END;

PROCEDURE DoneCom;
BEGIN
  CloseComm(Comm);
  Sec:=0;
  RecBuf:=[];
END;

FUNCTION CheckComm:Boolean;
VAR LastChar : Byte;
    Stat     : tComStat;
BEGIN
  GetCommError(Comm,Stat);
  CheckComm:=Stat.cbInQue>0;
  IF Stat.cbInQue>0 THEN
  BEGIN
    ReadComm(Comm,@LastChar,1);
    IF (GetTickCount-LastTime>1500)OR(Sec>58) THEN
    BEGIN
      IF (Sec=58)AND(CalcTime) THEN
      BEGIN
        MessageBeep(0);
        SetTime(Hour,Min,00,00);
        SetDate(Year,Month,Day);
      END;
      Sec:=0;
      RecBuf:=[];
    END ELSE
    BEGIN
      Inc(Sec);
      IF LastChar>100 THEN Exclude(RecBuf,Sec) ELSE Include(RecBuf,Sec);
    END;
    LastTime:=GetTickCount;
  END;
END;

PROCEDURE BufToBin(PC:pChar;Buf:tSecSET;NumDigits:Word);
VAR I:Word;
BEGIN
  PC^:=#0;
  FOR I:=NumDigits-1 DOWNTO 0 DO IF i IN BUF THEN StrCat(PC,'1') ELSE StrCat(PC,'0');
END;

PROCEDURE DisplayComm;
VAR PC:ARRAY[0..80]OF Char;
BEGIN
  Gotoxy(1,1);
  Writeln(Days[Dow]:3,',',Day:3,'.',Month:2,'.',Year:2,Hour:3,':',Min:2,'.',Sec:2);
  Writeln;
  Writeln(   '   55   50   45   40   35   30   25   20   15   10    5    0');
  StrCopy(PC,'....:....:....:....:....:....:....:....:....:....:....:....:');
  PC[59-Sec]:='|';
  Writeln(PC);
  BufToBin(PC,RecBuf,60);
  Writeln(PC);
END;

PROCEDURE Usage;
BEGIN
  MessageBox(0,'Usage: DCF32 <n>'#9'where n ist the number of the COM'#10+
                #9#9'port with the DCF77 module',NIL,MB_IconStop);
  Halt(0);
END;

VAR S:Word;
    P:STRING;
BEGIN
  IF (ParamCount<>1)
  OR (Length(Paramstr(1))<>1) THEN Usage;
  P:=ParamStr(1);
  S:=Ord(P[1])-Ord('0');
  IF NOT S IN [1..4] THEN Usage;
  IF InitCom(S) THEN
  BEGIN
    DisplayComm;
    REPEAT
      IF CheckComm THEN DisplayComm;
    UNTIL KeyPressed;
    DoneCom;
  END;
  DoneWinCrt;
END.