PAGE 58,132

TITLE DCF77 Radio Clock Decoder VxD
        .386p
        .XLIST
        INCLUDE VMM.Inc
        .LIST

Declare_Virtual_Device DCF77, 1, 0, VXD_Control, Undefined_Device_ID ,,,

VXD_REAL_INIT_SEG

real_init proc near
    mov ah, 9
    mov dx, offset copyright
    int 21h
    xor ax, ax          ; set up to tell Windows it's okay
    xor bx, bx          ; to keep loading this VxD
    xor si, si
    xor edx, edx
    ret
real_init endp

copyright   db  'Virtual DCF77 Radio Clock Decoder',0dh,0ah
            db  'Copyright (c) 1995 Kay Bruns. All Rights Reserved.'
            db  0dh,0ah,'$'

VXD_REAL_INIT_ENDS

VxD_LOCKED_DATA_SEG
;       Pagelocked data here - try to keep this to a minimum.

  Hour    DB 0
  Min     DB 0
;  DoW     DB 0
  Day     DB 0
  Month   DB 0
  Year    DB 0
  Rec1    DD 0
  Rec2    DD 0
  index   DB 0
  OffTime DW 0
  CntDwn  DB 2

  sto_eax DD 0
  sto_ecx DD 0
  sto_edx DD 0

VxD_LOCKED_DATA_ENDS

VxD_ICODE_SEG

;******************************************************************************
;
;   VXD_Device_Init
;
;   DESCRIPTION:
;       This is a shell for a routine that is called at system BOOT.
;       Typically, a VxD would do its initialization in this routine.
;
;   ENTRY:
;       EBX = System VM handle
;
;   EXIT:
;       Carry clear to indicate load success
;       Carry set to abort loading this VxD
;
;   USES:
;       flags
;
;==============================================================================

BeginProc VXD_Device_Init
	mov eax,1Ch
	mov esi,OFFSET32 IntProc
	VMMcall Hook_V86_Int_Chain
        ret
EndProc VXD_Device_Init

VxD_ICODE_ENDS

VxD_LOCKED_CODE_SEG

BeginProc IntProc
        mov  sto_edx,edx
        mov  sto_ecx,ecx
        mov  sto_eax,eax
        mov  dx,200h
        in   al,dx
        test ax,32
        jnz  short @1
        ; {Bit nicht gesetzt}
        inc  OffTime
        jmp  @Exit
    @1: ; { Bit gesetzt ==> LastOffTime auswerten: }
        ; { (30..38:Minute; 14..18:Low; 6..10:High }
        mov  ax,OffTime
        or   ax,ax
        je   @Exit
        mov  OffTime,0
        ; {Letztes Event war MinutenWechsel?}
        cmp  ax,50
        ja   @Error
        cmp  ax,22
        jb   @2
        cmp  Index,58
        jne  @Error
        ; {Letztes Bit fr Checksumme berechnen}
        cmp  ax,30
        ja   short @E1
        or   word ptr Rec1+6,0400h
    @E1:; {Check Bits: 1-14=0; 20=1}
        mov  ax,word ptr Rec1
        and  ax,7FFEh
        or   ax,ax
        jne  @Error
        test word ptr Rec1+2,4
        jz   @Error
        ; {Checksummen 21-27}
        mov  cx,7
        xor  dx,dx
        mov  ax,word ptr Rec1+2
        shr  ax,5
    @l1:shr  ax,1
        adc  dl,0
        loop @l1
        and  al,1
        and  dl,1
        cmp  al,dl
        jne  @Error
        ; {Checksummen 29-34}
        mov  cx,6
        xor  dx,dx
        mov  ax,word ptr Rec1+3
        shr  ax,5
    @l2:shr  ax,1
        adc  dl,0
        loop @l2
        and  al,1
        and  dl,1
        cmp  al,dl
        jne  @Error
        ; {Checksummen 36-57}
        mov  cx,22
        xor  dx,dx
        mov  eax,Rec1+4
        shr  eax,4
    @l3:shr  eax,1
        adc  dl,0
        loop @l3
        and  al,1
        and  dl,1
        cmp  al,dl
        jne  @Error
        ; {Zeit dekodieren}
        ; {Minuten: Bits 21..24 Lo; 25-27..Hi; 28 Paritt}
        mov  ax,word ptr Rec1+2 ; {Bits 16-31}
        shr  ax,5
        mov  ah,al
        and  al,15
        cmp  al,9
        ja   @Error
        shr  ah,4
        and  ah,7
        aad  ; {bcd>bin}
        cmp  al,59
        ja   @Error
        mov  Min,al
        ; {Stunden: Bits 29..32 Lo; 33,34..Hi; 35 Paritt}
        mov  ax,word ptr rec1+3 ; {Bits 24-39}
        shr  ax,5
        mov  ah,al
        and  al,15
        cmp  al,9
        ja   @Error
        shr  ah,4
        and  ah,3
        aad  ; {bcd>bin}
        cmp  al,23
        ja   @Error
        mov  Hour,al
        ; {Tag: Bits 36..39 Lo; 40,41..Hi}
        mov  ax,word ptr rec1+4 ; {Bits 32-47}
        shr  ax,4
        mov  ah,al
        and  al,15
        cmp  al,9
        ja   @Error
        shr  ah,4
        and  ah,3
        aad  ; {bcd>bin}
        cmp  al,31
        ja   @Error
        mov  Day,al
        ; {Wochentag: Bits 42..44}
;        mov  ax,word ptr rec1+5 ; {Bits 40-55}
;        shr  ax,2
;        and  al,7
;        mov  DoW,al
        ; {Monat: Bits 45..48 Lo; 49 Hi;}
        mov  ax,word ptr rec1+5 ; {Bits 40-55}
        shr  ax,5
        mov  ah,al
        and  al,15
        cmp  al,9
        ja   @Error
        shr  ah,4
        and  ah,1
        aad  ; {bcd>bin}
        cmp  al,12
        ja   @Error
        mov  Month,al
        ; {Jahr: Bits 50..53 Lo; 54-57..Hi; 58 Paritt fr Tag,Wochentag,Monat,Jahr}
        mov  ax,word ptr rec1+6 ; {Bits 48-63}
        shr  ax,2
        mov  ah,al
        and  al,15
        cmp  al,9
        ja   @Error
        shr  ah,4
        and  ah,15
        aad  ; {bcd>bin}
        cmp  al,99
        ja   @Error
        mov  Year,al
        ; {feetich}
        dec  CntDwn
        jnz  @Error
        mov  cntDwn,10
;#############################################################################
        ; {SetTime}
        MOV  CH,Hour
        MOV  CL,Min
        XOR  DX,DX
        MOV  AH,2DH
        VxDINT  21H
        ; {SetDate}
        MOV  CX,1900
        ADD  CL,Year
        CMP  Year,94
        JA   short @D1
        ADD  CX,100
    @D1:MOV  DH,Month
        MOV  DL,Day
        MOV  AH,2BH
        VxDINT  21H
;#############################################################################
        jmp  short @Error
    @2: ; {Letztes Event war Low?}
        cmp  ax,18
        ja   short @Error
        cmp  ax,14
        jb   short @3
        inc  index
        jmp  short @Exit
        ; {Letztes Event war High?}
    @3: cmp  ax,10
        ja   short @Error
        cmp  ax,6
        jb   short @Error
        xor  eax,eax
        inc  ax
        mov  cl,Index
        shl  eax,cl
        inc  Index
        cmp  cl,32
        jb   short @@1
        or   Rec1+4,eax
        jmp  short @exit
    @@1:
        or   Rec1,eax
        jmp  short @Exit
        ; {Synchronisation verloren!!!}
    @Error:
        mov  index,0
        mov  dword ptr Rec1,0
        mov  dword ptr Rec1+4,0
    @Exit:
        mov eax,sto_eax
        mov ecx,sto_ecx
        mov edx,sto_edx
	stc
	ret
EndProc IntProc

;******************************************************************************
;
;   VXD_Control
;
;   DESCRIPTION:
;
;       This is a call-back routine to handle the messages that are sent
;       to VxD's to control system operation. Every VxD needs this function
;       regardless if messages are processed or not. The control proc must
;       be in the LOCKED code segment.
;
;       The Control_Dispatch macro used in this procedure simplifies
;       the handling of messages. To handle a particular message, add
;       a Control_Dispatch statement with the message name, followed
;       by the procedure that should handle the message.
;
;       The two messages handled in this sample control proc, Device_Init
;       and Create_VM, are done only to illustrate how messages are
;       typically handled by a VxD. A VxD is not required to handle any
;       messages.
;
;   ENTRY:
;       EAX = Message number
;       EBX = VM Handle
;
;==============================================================================

BeginProc VXD_Control

        Control_Dispatch Device_Init, VXD_Device_Init
        clc
        ret

EndProc VXD_Control

VxD_LOCKED_CODE_ENDS

        END
